/*				MINLOG.C
*
*	This file contains the main function of the program MINLOG
*	which takes as input a series of sequents of propositional 
*	logic (input terminated by a blank line) and searches for 
*	minimal logic proofs of these.  The proofs can be printed 
*	if the program is called with the command line switch "-p"
*	or just the decisions can be output.
*/


#define MAINFILE
#include "minlog.h"



main( int argc, char *argv[] )
{
	SET Gamma, Dummy;
	int Con;

	prog_initial( argc, argv );

	while ( initialise(), got_sequent( &Gamma, &Con ) )
	proof_out( proved( &Gamma, Con, &Gamma, &Dummy ), &Gamma );

	if ( verbosity || graphs ) dump_events( prof_sum );
}
