/*				PROVER.H
*
*	This is the header specific to the prover module of the minimal
*	logic theorem prover minlog.c.  It contains only a few macros.
*/


#define DOUBLE_NEG(x) ( wff[wff[x].left].sym == '>' &&	\
		wff[wff[x].left].right == wff[x].right )

#define RETURN(rul,fml)					\
	{	if ( heap_ptr == HMAX-1 ) Abort("Proof heap exhausted"); \
		Heap[heap_ptr].rl = rul;		\
		Heap[heap_ptr].form = fml;		\
		Heap[heap_ptr].conc = Con;		\
		Heap[heap_ptr].lsprf = subproofs[0];	\
		Heap[heap_ptr].rsprf = subproofs[1];	\
		Extras->lowbits |= (Tau->lowbits & ~Gamma->lowbits); \
		Extras->highbits |= (Tau->highbits & ~Gamma->highbits); \
		return( Heap+(heap_ptr++) );		\
	}

#define NEWPREM(x) { putin( x, Delta );  putin( x, Delta2 ); }

#define L_SUBPROOF(x) subproofs[0] = proved( Delta, x, Delta2, Tau )

#define R_SUBPROOF(x) subproofs[1] = proved( Delta, x, Delta2, Tau )

#define RESET_DELTA { copyset( Gamma, Delta ); copyset( Gamma2, Delta2 ); }

#define NOLEFT subproofs[0] = 0

#define NORIGHT subproofs[1] = 0

#define ADD_TRUE { Delta->lowbits = (Gamma->lowbits | Tau->lowbits); \
	Delta->highbits = (Gamma->highbits | Tau->highbits); \
	add( true, Delta, Con ); \
	outbranch( Gamma, Con ); }

#define ADD_FALSE { add( false, Gamma, Con ); \
	outbranch( Gamma, Con ); }


#define report(x) Report(x,entry_count); 



/*
*	Note that Double_Neg assumes the wff to be an implication.
*
*	Return and Newprem have terminating semicolons allowing them to
*	be used like compound statements.  Note that they do not require any 
*	semicolons when they are invoked in the text of the functions.
*	Subproof does not have a terminating semicolon, so it can be used
*	to return a value.
*/
